﻿#Automated installation steps based on the official manual steps at
#https://github.com/neovim/neovim/wiki/Installing-Neovim#windows

$ErrorActionPreference = 'Stop'; 

$packageName= 'neovim'
$toolsDir   = "$(Split-Path -parent $MyInvocation.MyCommand.Definition)"
$url        = 'https://ci.appveyor.com/api/buildjobs/6pv8wx6lwh70wbxk/artifacts/build/Neovim.zip' 
$url64      = 'https://ci.appveyor.com/api/buildjobs/vl9b76gwefah4sm3/artifacts/build/Neovim.zip'
$neovimQtUrl = "https://github.com/equalsraf/neovim-qt/releases/download/staging/neovim-qt.zip"
$exeNotToIgnore='neovim.exe'

$neovimPackageArgs = @{
  packageName   = $packageName
  unzipLocation = $toolsDir
  url           = $url
  url64bit      = $url64
  validExitCodes= @(0) 
  softwareName  = 'Neovim*' 
  checksum      = ''
  checksumType  = 'md5' 
  checksum64    = ''
  checksumType64= 'md5' 
}
$neovimQtPackageArgs = @{
  packageName   = $packageName
  unzipLocation = $toolsDir
  url           = $neovimQtUrl
  url64bit      = $neovimQtUrl
  validExitCodes= @(0) 
  softwareName  = 'Neovim*' 
  checksum      = ''
  checksumType  = 'md5' 
  checksum64    = ''
  checksumType64= 'md5' 
}

function MergeApplicationDirectories($neovimDirectory, $neovimQtDirectory) {
    Move-Item -Path "$neovimDirectory\NeoVim\bin\*" -Destination $neovimQtDirectory
    Move-Item -Path "$neovimDirectory\NeoVim\share\nvim\runtime\*" -Destination $neovimQtDirectory
    Move-Item -Path "$neovimQtDirectory\nvim-qt.exe" -Destination $neovimQtDirectory\neovim.exe
}

function IgnoreToolsExecutables() {
  Get-ChildItem ".\*" -Force -Include *.exe -Exclude $exeNotToIgnore | % { '' > "$_.ignore" }
}

Install-ChocolateyZipPackage @neovimQtPackageArgs
Install-ChocolateyZipPackage @neovimPackageArgs

Push-Location "$toolsDir"
IgnoreToolsExecutables 
Pop-Location

